define a minimum PATH environment
[strongswan.git] / src / _updown / _updown.in
1 #! /bin/sh
2 # iproute2 version, default updown script
3 #
4 # Copyright (C) 2003-2004 Nigel Meteringham
5 # Copyright (C) 2003-2004 Tuomo Soini
6 # Copyright (C) 2002-2004 Michael Richardson
7 # Copyright (C) 2005-2007 Andreas Steffen <andreas.steffen@strongswan.org>
8
9 # This program is free software; you can redistribute it and/or modify it
10 # under the terms of the GNU General Public License as published by the
11 # Free Software Foundation; either version 2 of the License, or (at your
12 # option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
13
14 # This program is distributed in the hope that it will be useful, but
15 # WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
16 # or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
17 # for more details.
18 #
19 # RCSID $Id$
20
21 # CAUTION:  Installing a new version of strongSwan will install a new
22 # copy of this script, wiping out any custom changes you make.  If
23 # you need changes, make a copy of this under another name, and customize
24 # that, and use the (left/right)updown parameters in ipsec.conf to make
25 # strongSwan use yours instead of this default one.
26
27 # things that this script gets (from ipsec_pluto(8) man page)
28 #
29 #      PLUTO_VERSION
30 #              indicates  what  version of this interface is being
31 #              used.  This document describes version  1.1.   This
32 #              is upwardly compatible with version 1.0.
33 #
34 #       PLUTO_VERB
35 #              specifies the name of the operation to be performed
36 #              (prepare-host, prepare-client, up-host, up-client,
37 #              down-host, or down-client).  If the address family
38 #              for security gateway to security gateway communica¬≠
39 #              tions is IPv6, then a suffix of -v6 is added to the
40 #              verb.
41 #
42 #       PLUTO_CONNECTION
43 #              is the name of the  connection  for  which  we  are
44 #              routing.
45 #
46 #       PLUTO_NEXT_HOP
47 #              is the next hop to which packets bound for the peer
48 #              must be sent.
49 #
50 #       PLUTO_INTERFACE
51 #              is the name of the ipsec interface to be used.
52 #
53 #       PLUTO_REQID
54 #              is the requid of the ESP policy
55 #
56 #       PLUTO_ME
57 #              is the IP address of our host.
58 #
59 #       PLUTO_MY_ID
60 #              is the ID of our host.
61 #
62 #       PLUTO_MY_CLIENT
63 #              is the IP address / count of our client subnet.  If
64 #              the  client  is  just  the  host,  this will be the
65 #              host's own IP address / max (where max  is  32  for
66 #              IPv4 and 128 for IPv6).
67 #
68 #       PLUTO_MY_CLIENT_NET
69 #              is the IP address of our client net.  If the client
70 #              is just the host, this will be the  host's  own  IP
71 #              address.
72 #
73 #       PLUTO_MY_CLIENT_MASK
74 #              is  the  mask for our client net.  If the client is
75 #              just the host, this will be 255.255.255.255.
76 #
77 #       PLUTO_MY_SOURCEIP
78 #              if non-empty, then the source address for the route will be
79 #              set to this IP address.
80 #
81 #       PLUTO_MY_PROTOCOL
82 #              is the IP protocol that will be transported.
83 #
84 #       PLUTO_MY_PORT
85 #              is  the  UDP/TCP  port  to  which  the IPsec SA  is
86 #              restricted on our side.
87 #
88 #       PLUTO_PEER
89 #              is the IP address of our peer.
90 #
91 #       PLUTO_PEER_ID
92 #              is the ID of our peer.
93 #
94 #       PLUTO_PEER_CA
95 #              is the CA which issued the cert of our peer.
96 #
97 #       PLUTO_PEER_CLIENT
98 #              is the IP address / count of the peer's client sub¬≠
99 #              net.   If the client is just the peer, this will be
100 #              the peer's own IP address / max (where  max  is  32
101 #              for IPv4 and 128 for IPv6).
102 #
103 #       PLUTO_PEER_CLIENT_NET
104 #              is the IP address of the peer's client net.  If the
105 #              client is just the peer, this will  be  the  peer's
106 #              own IP address.
107 #
108 #       PLUTO_PEER_CLIENT_MASK
109 #              is  the  mask  for  the  peer's client net.  If the
110 #              client   is   just   the   peer,   this   will   be
111 #              255.255.255.255.
112 #
113 #       PLUTO_PEER_PROTOCOL
114 #              is the IP protocol that will be transported.
115 #
116 #       PLUTO_PEER_PORT
117 #              is  the  UDP/TCP  port  to  which  the IPsec SA  is
118 #              restricted on the peer side.
119 #
120
121 # define a minimum PATH environment in case it is not set
122 PATH="/sbin:/bin:/usr/sbin:/usr/bin"
123 export PATH
124
125 # uncomment to log VPN connections
126 VPN_LOGGING=1
127 #
128 # tag put in front of each log entry:
129 TAG=vpn
130 #
131 # syslog facility and priority used:
132 FAC_PRIO=local0.notice
133 #
134 # to create a special vpn logging file, put the following line into
135 # the syslog configuration file /etc/syslog.conf:
136 #
137 # local0.notice                   -/var/log/vpn
138
139 # in order to use source IP routing the Linux kernel options
140 # CONFIG_IP_ADVANCED_ROUTER and CONFIG_IP_MULTIPLE_TABLES
141 # must be enabled
142 #
143 # special routing table for sourceip routes
144 SOURCEIP_ROUTING_TABLE=@IPSEC_ROUTING_TABLE@
145 #
146 # priority of the sourceip routing table
147 SOURCEIP_ROUTING_TABLE_PRIO=@IPSEC_ROUTING_TABLE_PRIO@
148
149 # check interface version
150 case "$PLUTO_VERSION" in
151 1.[0|1])        # Older Pluto?!?  Play it safe, script may be using new features.
152         echo "$0: obsolete interface version \`$PLUTO_VERSION'," >&2
153         echo "$0:       called by obsolete Pluto?" >&2
154         exit 2
155         ;;
156 1.*)    ;;
157 *)      echo "$0: unknown interface version \`$PLUTO_VERSION'" >&2
158         exit 2
159         ;;
160 esac
161
162 # check parameter(s)
163 case "$1:$*" in
164 ':')                    # no parameters
165         ;;
166 iptables:iptables)      # due to (left/right)firewall; for default script only
167         ;;
168 custom:*)               # custom parameters (see above CAUTION comment)
169         ;;
170 *)      echo "$0: unknown parameters \`$*'" >&2
171         exit 2
172         ;;
173 esac
174
175 # utility functions for route manipulation
176 # Meddling with this stuff should not be necessary and requires great care.
177 uproute() {
178         doroute add
179         ip route flush cache
180 }
181 downroute() {
182         doroute delete
183         ip route flush cache
184 }
185
186 addsource() {
187         st=0
188         if ! ip -o route get ${PLUTO_MY_SOURCEIP%/*} | grep -q ^local
189         then
190             it="ip addr add ${PLUTO_MY_SOURCEIP%/*}/32 dev $PLUTO_INTERFACE"
191             oops="`eval $it 2>&1`"
192             st=$?
193             if test " $oops" = " " -a " $st" != " 0"
194             then
195                 oops="silent error, exit status $st"
196             fi
197             if test " $oops" != " " -o " $st" != " 0"
198             then
199                 echo "$0: addsource \`$it' failed ($oops)" >&2
200             fi
201         fi
202         return $st
203 }
204
205 doroute() {
206         st=0
207
208         if [ -z "$PLUTO_MY_SOURCEIP" ]
209         then
210             if [ -f /etc/sysconfig/defaultsource ]
211             then
212                 . /etc/sysconfig/defaultsource
213             fi
214
215             if [ -f /etc/conf.d/defaultsource ]
216             then
217                 . /etc/conf.d/defaultsource
218             fi
219
220             if [ -n "$DEFAULTSOURCE" ]
221             then
222                 PLUTO_MY_SOURCEIP=$DEFAULTSOURCE
223             fi
224         fi
225
226         if [ -z "$KLIPS" -a -z "$PLUTO_MY_SOURCEIP" ]
227         then
228             # leave because no route entry is required
229             return $st
230         fi
231
232         parms1="$PLUTO_PEER_CLIENT"
233
234         if [ -n "$PLUTO_NEXT_HOP" ]
235         then
236             parms2="via $PLUTO_NEXT_HOP"
237         else
238             parms2="via $PLUTO_PEER"
239         fi      
240         parms2="$parms2 dev $PLUTO_INTERFACE"
241
242         parms3=
243         if [ -n "$PLUTO_MY_SOURCEIP" ]
244         then
245             if test "$1" = "add"
246             then
247                 addsource
248                 if ! ip rule list | grep -q "lookup $SOURCEIP_ROUTING_TABLE"
249                 then
250                     ip rule add pref $SOURCEIP_ROUTING_TABLE_PRIO table $SOURCEIP_ROUTING_TABLE
251                 fi
252             fi
253             parms3="$parms3 src ${PLUTO_MY_SOURCEIP%/*} table $SOURCEIP_ROUTING_TABLE"
254         fi
255
256         case "$PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK" in
257         "0.0.0.0/0.0.0.0")
258                 # opportunistic encryption work around
259                 # need to provide route that eclipses default, without 
260                 # replacing it.
261                 it="ip route $1 0.0.0.0/1 $parms2 $parms3 &&
262                         ip route $1 128.0.0.0/1 $parms2 $parms3"
263                 ;;
264         *)      it="ip route $1 $parms1 $parms2 $parms3"
265                 ;;
266         esac
267         oops="`eval $it 2>&1`"
268         st=$?
269         if test " $oops" = " " -a " $st" != " 0"
270         then
271             oops="silent error, exit status $st"
272         fi
273         if test " $oops" != " " -o " $st" != " 0"
274         then
275             echo "$0: doroute \`$it' failed ($oops)" >&2
276         fi
277         return $st
278 }
279  
280 # in the presence of KLIPS and ipsecN interfaces do not use IPSEC_POLICY 
281 if [ `echo "$PLUTO_INTERFACE" | grep "ipsec"` ]
282 then
283         KLIPS=1
284         IPSEC_POLICY_IN=""
285         IPSEC_POLICY_OUT=""
286 else
287         KLIPS=
288         IPSEC_POLICY="-m policy --pol ipsec --proto esp --reqid $PLUTO_REQID"
289         IPSEC_POLICY_IN="$IPSEC_POLICY --dir in"
290         IPSEC_POLICY_OUT="$IPSEC_POLICY --dir out"
291 fi
292
293 # are there port numbers?
294 if [ "$PLUTO_MY_PORT" != 0 ]
295 then
296         S_MY_PORT="--sport $PLUTO_MY_PORT"
297         D_MY_PORT="--dport $PLUTO_MY_PORT"
298 fi
299 if [ "$PLUTO_PEER_PORT" != 0 ]
300 then
301         S_PEER_PORT="--sport $PLUTO_PEER_PORT"
302         D_PEER_PORT="--dport $PLUTO_PEER_PORT"
303 fi
304
305 # the big choice
306 case "$PLUTO_VERB:$1" in
307 prepare-host:*|prepare-client:*)
308         if [ -z "$KLIPS" -a -z "$PLUTO_MY_SOURCEIP" ]
309         then
310             # exit because no route will be added,
311             # so that existing routes can stay
312             exit 0
313         fi
314
315         # delete possibly-existing route (preliminary to adding a route)
316         case "$PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK" in
317         "0.0.0.0/0.0.0.0")
318                 # need to provide route that eclipses default, without 
319                 # replacing it.
320                 parms1="0.0.0.0/1"
321                 parms2="128.0.0.0/1"
322                 it="ip route delete $parms1 2>&1 ; ip route delete $parms2 2>&1"
323                 oops="`ip route delete $parms1 2>&1 ; ip route delete $parms2 2>&1`"
324                 ;;
325         *)
326                 parms="$PLUTO_PEER_CLIENT"
327                 it="ip route delete $parms 2>&1"
328                 oops="`ip route delete $parms 2>&1`"
329                 ;;
330         esac
331         status="$?"
332         if test " $oops" = " " -a " $status" != " 0"
333         then
334                 oops="silent error, exit status $status"
335         fi
336         case "$oops" in
337         *'RTNETLINK answers: No such process'*) 
338                 # This is what route (currently -- not documented!) gives
339                 # for "could not find such a route".
340                 oops=
341                 status=0
342                 ;;
343         esac
344         if test " $oops" != " " -o " $status" != " 0"
345         then
346                 echo "$0: \`$it' failed ($oops)" >&2
347         fi
348         exit $status
349         ;;
350 route-host:*|route-client:*)
351         # connection to me or my client subnet being routed
352         uproute
353         ;;
354 unroute-host:*|unroute-client:*)
355         # connection to me or my client subnet being unrouted
356         downroute
357         ;;
358 up-host:)
359         # connection to me coming up
360         # If you are doing a custom version, firewall commands go here.
361         ;;
362 down-host:)
363         # connection to me going down
364         # If you are doing a custom version, firewall commands go here.
365         ;;
366 up-client:)
367         # connection to my client subnet coming up
368         # If you are doing a custom version, firewall commands go here.
369         ;;
370 down-client:)
371         # connection to my client subnet going down
372         # If you are doing a custom version, firewall commands go here.
373         ;;
374 up-host:iptables)
375         # connection to me, with (left/right)firewall=yes, coming up
376         # This is used only by the default updown script, not by your custom
377         # ones, so do not mess with it; see CAUTION comment up at top.
378         iptables -I INPUT 1 -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
379             -s $PLUTO_PEER_CLIENT $S_PEER_PORT \
380             -d $PLUTO_ME $D_MY_PORT $IPSEC_POLICY_IN -j ACCEPT
381         iptables -I OUTPUT 1 -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
382             -s $PLUTO_ME $S_MY_PORT $IPSEC_POLICY_OUT \
383             -d $PLUTO_PEER_CLIENT $D_PEER_PORT -j ACCEPT
384         #
385         # log IPsec host connection setup
386         if [ $VPN_LOGGING ]
387         then
388           if [ "$PLUTO_PEER_CLIENT" == "$PLUTO_PEER/32" ]
389           then
390             logger -t $TAG -p $FAC_PRIO \
391               "+ `echo -e $PLUTO_PEER_ID` $PLUTO_PEER -- $PLUTO_ME"
392           else
393             logger -t $TAG -p $FAC_PRIO \
394               "+ `echo -e $PLUTO_PEER_ID` $PLUTO_PEER_CLIENT == $PLUTO_PEER -- $PLUTO_ME"
395           fi
396         fi      
397         ;;
398 down-host:iptables)
399         # connection to me, with (left/right)firewall=yes, going down
400         # This is used only by the default updown script, not by your custom
401         # ones, so do not mess with it; see CAUTION comment up at top.
402         iptables -D INPUT -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
403             -s $PLUTO_PEER_CLIENT $S_PEER_PORT \
404             -d $PLUTO_ME $D_MY_PORT $IPSEC_POLICY_IN -j ACCEPT
405         iptables -D OUTPUT -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
406             -s $PLUTO_ME $S_MY_PORT $IPSEC_POLICY_OUT \
407             -d $PLUTO_PEER_CLIENT $D_PEER_PORT -j ACCEPT
408         #
409         # log IPsec host connection teardown
410         if [ $VPN_LOGGING ]
411         then
412           if [ "$PLUTO_PEER_CLIENT" == "$PLUTO_PEER/32" ]
413           then
414             logger -t $TAG -p $FAC_PRIO -- \
415               "- `echo -e $PLUTO_PEER_ID` $PLUTO_PEER -- $PLUTO_ME"
416           else
417             logger -t $TAG -p $FAC_PRIO -- \
418             "- `echo -e $PLUTO_PEER_ID` $PLUTO_PEER_CLIENT == $PLUTO_PEER -- $PLUTO_ME"
419           fi
420         fi
421         ;;
422 up-client:iptables)
423         # connection to client subnet, with (left/right)firewall=yes, coming up
424         # This is used only by the default updown script, not by your custom
425         # ones, so do not mess with it; see CAUTION comment up at top.
426         if [ "$PLUTO_PEER_CLIENT" != "$PLUTO_MY_SOURCEIP/32" ]
427         then
428           iptables -I FORWARD 1 -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
429               -s $PLUTO_MY_CLIENT $S_MY_PORT \
430               -d $PLUTO_PEER_CLIENT $D_PEER_PORT $IPSEC_POLICY_OUT -j ACCEPT
431           iptables -I FORWARD 1 -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
432               -s $PLUTO_PEER_CLIENT $S_PEER_PORT \
433               -d $PLUTO_MY_CLIENT $D_MY_PORT $IPSEC_POLICY_IN -j ACCEPT
434         fi
435         #
436         # a virtual IP requires an INPUT and OUTPUT rule on the host
437         # or sometimes host access via the internal IP is needed
438         if [ -n "$PLUTO_MY_SOURCEIP" -o -n "$PLUTO_HOST_ACCESS" ]
439         then
440           iptables -I INPUT 1 -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
441               -s $PLUTO_PEER_CLIENT $S_PEER_PORT \
442               -d $PLUTO_MY_CLIENT $D_MY_PORT $IPSEC_POLICY_IN -j ACCEPT
443           iptables -I OUTPUT 1 -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
444               -s $PLUTO_MY_CLIENT $S_MY_PORT \
445               -d $PLUTO_PEER_CLIENT $D_PEER_PORT $IPSEC_POLICY_OUT -j ACCEPT
446         fi
447         #
448         # log IPsec client connection setup
449         if [ $VPN_LOGGING ]
450         then
451           if [ "$PLUTO_PEER_CLIENT" == "$PLUTO_PEER/32" ]
452           then
453             logger -t $TAG -p $FAC_PRIO \
454               "+ `echo -e $PLUTO_PEER_ID` $PLUTO_PEER -- $PLUTO_ME == $PLUTO_MY_CLIENT"
455           else
456             logger -t $TAG -p $FAC_PRIO \
457               "+ `echo -e $PLUTO_PEER_ID` $PLUTO_PEER_CLIENT == $PLUTO_PEER -- $PLUTO_ME == $PLUTO_MY_CLIENT"
458           fi
459         fi
460         ;;
461 down-client:iptables)
462         # connection to client subnet, with (left/right)firewall=yes, going down
463         # This is used only by the default updown script, not by your custom
464         # ones, so do not mess with it; see CAUTION comment up at top.
465         if [ "$PLUTO_PEER_CLIENT" != "$PLUTO_MY_SOURCEIP/32" ]
466         then
467           iptables -D FORWARD -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
468               -s $PLUTO_MY_CLIENT $S_MY_PORT \
469               -d $PLUTO_PEER_CLIENT $D_PEER_PORT \
470                  $IPSEC_POLICY_OUT -j ACCEPT
471           iptables -D FORWARD -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
472               -s $PLUTO_PEER_CLIENT $S_PEER_PORT \
473               -d $PLUTO_MY_CLIENT $D_MY_PORT \
474                  $IPSEC_POLICY_IN -j ACCEPT
475         fi
476         #
477         # a virtual IP requires an INPUT and OUTPUT rule on the host
478         # or sometimes host access via the internal IP is needed
479         if [ -n "$PLUTO_MY_SOURCEIP" -o -n "$PLUTO_HOST_ACCESS" ]
480         then
481           iptables -D INPUT -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
482               -s $PLUTO_PEER_CLIENT $S_PEER_PORT \
483               -d $PLUTO_MY_CLIENT $D_MY_PORT \
484                  $IPSEC_POLICY_IN -j ACCEPT
485           iptables -D OUTPUT -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
486               -s $PLUTO_MY_CLIENT $S_MY_PORT \
487               -d $PLUTO_PEER_CLIENT $D_PEER_PORT \
488                  $IPSEC_POLICY_OUT -j ACCEPT
489         fi
490         #
491         # log IPsec client connection teardown
492         if [ $VPN_LOGGING ]
493         then
494           if [ "$PLUTO_PEER_CLIENT" == "$PLUTO_PEER/32" ]
495           then
496             logger -t $TAG -p $FAC_PRIO -- \
497               "- `echo -e $PLUTO_PEER_ID` $PLUTO_PEER -- $PLUTO_ME == $PLUTO_MY_CLIENT"
498           else
499             logger -t $TAG -p $FAC_PRIO -- \
500               "- `echo -e $PLUTO_PEER_ID` $PLUTO_PEER_CLIENT == $PLUTO_PEER -- $PLUTO_ME == $PLUTO_MY_CLIENT"
501           fi
502         fi
503         ;;
504 #
505 # IPv6
506 #
507 prepare-host-v6:*|prepare-client-v6:*)
508         ;;
509 route-host-v6:*|route-client-v6:*)
510         # connection to me or my client subnet being routed
511         #uproute_v6
512         ;;
513 unroute-host-v6:*|unroute-client-v6:*)
514         # connection to me or my client subnet being unrouted
515         #downroute_v6
516         ;;
517 up-host-v6:)
518         # connection to me coming up
519         # If you are doing a custom version, firewall commands go here.
520         ;;
521 down-host-v6:)
522         # connection to me going down
523         # If you are doing a custom version, firewall commands go here.
524         ;;
525 up-client-v6:)
526         # connection to my client subnet coming up
527         # If you are doing a custom version, firewall commands go here.
528         ;;
529 down-client-v6:)
530         # connection to my client subnet going down
531         # If you are doing a custom version, firewall commands go here.
532         ;;
533 up-host-v6:iptables)
534         # connection to me, with (left/right)firewall=yes, coming up
535         # This is used only by the default updown script, not by your custom
536         # ones, so do not mess with it; see CAUTION comment up at top.
537         ip6tables -I INPUT 1 -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
538             -s $PLUTO_PEER_CLIENT $S_PEER_PORT \
539             -d $PLUTO_ME $D_MY_PORT $IPSEC_POLICY_IN -j ACCEPT
540         ip6tables -I OUTPUT 1 -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
541             -s $PLUTO_ME $S_MY_PORT $IPSEC_POLICY_OUT \
542             -d $PLUTO_PEER_CLIENT $D_PEER_PORT -j ACCEPT
543         #
544         # log IPsec host connection setup
545         if [ $VPN_LOGGING ]
546         then
547           if [ "$PLUTO_PEER_CLIENT" == "$PLUTO_PEER/128" ]
548           then
549             logger -t $TAG -p $FAC_PRIO \
550               "+ `echo -e $PLUTO_PEER_ID` $PLUTO_PEER -- $PLUTO_ME"
551           else
552             logger -t $TAG -p $FAC_PRIO \
553               "+ `echo -e $PLUTO_PEER_ID` $PLUTO_PEER_CLIENT == $PLUTO_PEER -- $PLUTO_ME"
554           fi
555         fi      
556         ;;
557 down-host-v6:iptables)
558         # connection to me, with (left/right)firewall=yes, going down
559         # This is used only by the default updown script, not by your custom
560         # ones, so do not mess with it; see CAUTION comment up at top.
561         ip6tables -D INPUT -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
562             -s $PLUTO_PEER_CLIENT $S_PEER_PORT \
563             -d $PLUTO_ME $D_MY_PORT $IPSEC_POLICY_IN -j ACCEPT
564         ip6tables -D OUTPUT -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
565             -s $PLUTO_ME $S_MY_PORT $IPSEC_POLICY_OUT \
566             -d $PLUTO_PEER_CLIENT $D_PEER_PORT -j ACCEPT
567         #
568         # log IPsec host connection teardown
569         if [ $VPN_LOGGING ]
570         then
571           if [ "$PLUTO_PEER_CLIENT" == "$PLUTO_PEER/128" ]
572           then
573             logger -t $TAG -p $FAC_PRIO -- \
574               "- `echo -e $PLUTO_PEER_ID` $PLUTO_PEER -- $PLUTO_ME"
575           else
576             logger -t $TAG -p $FAC_PRIO -- \
577             "- `echo -e $PLUTO_PEER_ID` $PLUTO_PEER_CLIENT == $PLUTO_PEER -- $PLUTO_ME"
578           fi
579         fi
580         ;;
581 up-client-v6:iptables)
582         # connection to client subnet, with (left/right)firewall=yes, coming up
583         # This is used only by the default updown script, not by your custom
584         # ones, so do not mess with it; see CAUTION comment up at top.
585         if [ "$PLUTO_PEER_CLIENT" != "$PLUTO_MY_SOURCEIP/128" ]
586         then
587           ip6tables -I FORWARD 1 -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
588               -s $PLUTO_MY_CLIENT $S_MY_PORT \
589               -d $PLUTO_PEER_CLIENT $D_PEER_PORT $IPSEC_POLICY_OUT -j ACCEPT
590           ip6tables -I FORWARD 1 -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
591               -s $PLUTO_PEER_CLIENT $S_PEER_PORT \
592               -d $PLUTO_MY_CLIENT $D_MY_PORT $IPSEC_POLICY_IN -j ACCEPT
593         fi
594         #
595         # a virtual IP requires an INPUT and OUTPUT rule on the host
596         # or sometimes host access via the internal IP is needed
597         if [ -n "$PLUTO_MY_SOURCEIP" -o -n "$PLUTO_HOST_ACCESS" ]
598         then
599           ip6tables -I INPUT 1 -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
600               -s $PLUTO_PEER_CLIENT $S_PEER_PORT \
601               -d $PLUTO_MY_CLIENT $D_MY_PORT $IPSEC_POLICY_IN -j ACCEPT
602           ip6tables -I OUTPUT 1 -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
603               -s $PLUTO_MY_CLIENT $S_MY_PORT \
604               -d $PLUTO_PEER_CLIENT $D_PEER_PORT $IPSEC_POLICY_OUT -j ACCEPT
605         fi
606         #
607         # log IPsec client connection setup
608         if [ $VPN_LOGGING ]
609         then
610           if [ "$PLUTO_PEER_CLIENT" == "$PLUTO_PEER/128" ]
611           then
612             logger -t $TAG -p $FAC_PRIO \
613               "+ `echo -e $PLUTO_PEER_ID` $PLUTO_PEER -- $PLUTO_ME == $PLUTO_MY_CLIENT"
614           else
615             logger -t $TAG -p $FAC_PRIO \
616               "+ `echo -e $PLUTO_PEER_ID` $PLUTO_PEER_CLIENT == $PLUTO_PEER -- $PLUTO_ME == $PLUTO_MY_CLIENT"
617           fi
618         fi
619         ;;
620 down-client-v6:iptables)
621         # connection to client subnet, with (left/right)firewall=yes, going down
622         # This is used only by the default updown script, not by your custom
623         # ones, so do not mess with it; see CAUTION comment up at top.
624         if [ "$PLUTO_PEER_CLIENT" != "$PLUTO_MY_SOURCEIP/128" ]
625         then
626           ip6tables -D FORWARD -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
627               -s $PLUTO_MY_CLIENT $S_MY_PORT \
628               -d $PLUTO_PEER_CLIENT $D_PEER_PORT \
629                  $IPSEC_POLICY_OUT -j ACCEPT
630           ip6tables -D FORWARD -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
631               -s $PLUTO_PEER_CLIENT $S_PEER_PORT \
632               -d $PLUTO_MY_CLIENT $D_MY_PORT \
633                  $IPSEC_POLICY_IN -j ACCEPT
634         fi
635         #
636         # a virtual IP requires an INPUT and OUTPUT rule on the host
637         # or sometimes host access via the internal IP is needed
638         if [ -n "$PLUTO_MY_SOURCEIP" -o -n "$PLUTO_HOST_ACCESS" ]
639         then
640           ip6tables -D INPUT -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
641               -s $PLUTO_PEER_CLIENT $S_PEER_PORT \
642               -d $PLUTO_MY_CLIENT $D_MY_PORT \
643                  $IPSEC_POLICY_IN -j ACCEPT
644           ip6tables -D OUTPUT -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
645               -s $PLUTO_MY_CLIENT $S_MY_PORT \
646               -d $PLUTO_PEER_CLIENT $D_PEER_PORT \
647                  $IPSEC_POLICY_OUT -j ACCEPT
648         fi
649         #
650         # log IPsec client connection teardown
651         if [ $VPN_LOGGING ]
652         then
653           if [ "$PLUTO_PEER_CLIENT" == "$PLUTO_PEER/128" ]
654           then
655             logger -t $TAG -p $FAC_PRIO -- \
656               "- `echo -e $PLUTO_PEER_ID` $PLUTO_PEER -- $PLUTO_ME == $PLUTO_MY_CLIENT"
657           else
658             logger -t $TAG -p $FAC_PRIO -- \
659               "- `echo -e $PLUTO_PEER_ID` $PLUTO_PEER_CLIENT == $PLUTO_PEER -- $PLUTO_ME == $PLUTO_MY_CLIENT"
660           fi
661         fi
662         ;;
663 *)      echo "$0: unknown verb \`$PLUTO_VERB' or parameter \`$1'" >&2
664         exit 1
665         ;;
666 esac